// Code generated by gobind. DO NOT EDIT.

// Java class com.proton.gopenpgp.helper.Helper is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/gopenpgp/v2/helper
package com.proton.gopenpgp.helper;

import go.Seq;

public abstract class Helper {
	static {
		Seq.touch(); // for loading the native library
		com.proton.gopenpgp.crypto.Crypto.touch();
		_init();
	}
	
	private Helper() {} // uninstantiable
	
	// touch is called from other bound packages to initialize this package
	public static void touch() {}
	
	private static native void _init();
	
	private static final class proxyMobileReader implements Seq.Proxy, MobileReader {
		private final int refnum;
		
		@Override public final int incRefnum() {
		      Seq.incGoRef(refnum, this);
		      return refnum;
		}
		
		proxyMobileReader(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
		
		public native MobileReadResult read(long max) throws Exception;
	}
	
	
	/**
	 * DecryptAttachment takes a keypacket and datpacket
	and returns a decrypted PlainMessage
	Specifically designed for attachments rather than text messages.
	 */
	public static native com.proton.gopenpgp.crypto.PlainMessage decryptAttachment(byte[] keyPacket, byte[] dataPacket, com.proton.gopenpgp.crypto.KeyRing keyRing) throws Exception;
	/**
	 * DecryptAttachmentWithKey decrypts a binary file
	Using a given armored private key and its passphrase.
	 */
	public static native byte[] decryptAttachmentWithKey(String privateKey, byte[] passphrase, byte[] keyPacket, byte[] dataPacket) throws Exception;
	/**
	 * DecryptBinaryMessageArmored decrypts an armored PGP message given a private key
	and its passphrase.
	 */
	public static native byte[] decryptBinaryMessageArmored(String privateKey, byte[] passphrase, String ciphertext) throws Exception;
	/**
	 * DecryptExplicitVerify decrypts a PGP message given a private keyring
	and a public keyring to verify the embedded signature. Returns the plain
	data and an error on signature verification failure.
	 */
	public static native ExplicitVerifyMessage decryptExplicitVerify(com.proton.gopenpgp.crypto.PGPMessage pgpMessage, com.proton.gopenpgp.crypto.KeyRing privateKeyRing, com.proton.gopenpgp.crypto.KeyRing publicKeyRing, long verifyTime) throws Exception;
	/**
	 * DecryptMessageArmored decrypts an armored PGP message given a private key
	and its passphrase.
	 */
	public static native String decryptMessageArmored(String privateKey, byte[] passphrase, String ciphertext) throws Exception;
	/**
	 * DecryptMessageWithPassword decrypts an armored message with a random token.
	The algorithm is derived from the armoring.
	 */
	public static native String decryptMessageWithPassword(byte[] password, String ciphertext) throws Exception;
	/**
	 * DecryptSessionKey decrypts a session key
	using a given armored private key
	and its passphrase.
	 */
	public static native com.proton.gopenpgp.crypto.SessionKey decryptSessionKey(String privateKey, byte[] passphrase, byte[] encryptedSessionKey) throws Exception;
	/**
	 * DecryptSessionKeyExplicitVerify decrypts a PGP data packet given a session key
	and a public keyring to verify the embedded signature. Returns the plain data and
	an error on signature verification failure.
	 */
	public static native ExplicitVerifyMessage decryptSessionKeyExplicitVerify(byte[] dataPacket, com.proton.gopenpgp.crypto.SessionKey sessionKey, com.proton.gopenpgp.crypto.KeyRing publicKeyRing, long verifyTime) throws Exception;
	/**
	 * DecryptVerifyArmoredDetached decrypts an armored pgp message
	and verify a detached armored encrypted signature
	given a publicKey, and a privateKey with its passphrase.
	Returns the plain data or an error on
	signature verification failure.
	 */
	public static native byte[] decryptVerifyArmoredDetached(String publicKey, String privateKey, byte[] passphrase, String ciphertextArmored, String encryptedSignatureArmored) throws Exception;
	/**
	 * DecryptVerifyAttachment decrypts and verifies an attachment split into the
	keyPacket, dataPacket and an armored (!) signature, given a publicKey, and a
	privateKey with its passphrase. Returns the plain data or an error on
	signature verification failure.
	 */
	public static native byte[] decryptVerifyAttachment(String publicKey, String privateKey, byte[] passphrase, byte[] keyPacket, byte[] dataPacket, String armoredSignature) throws Exception;
	/**
	 * DecryptVerifyBinaryDetached decrypts binary encrypted data
	and verify a detached armored encrypted signature
	given a publicKey, and a privateKey with its passphrase.
	Returns the plain data or an error on
	signature verification failure.
	 */
	public static native byte[] decryptVerifyBinaryDetached(String publicKey, String privateKey, byte[] passphrase, byte[] encryptedData, String encryptedSignatureArmored) throws Exception;
	/**
	 * DecryptVerifyMessageArmored decrypts an armored PGP message given a private
	key and its passphrase and verifies the embedded signature. Returns the
	plain data or an error on signature verification failure.
	 */
	public static native String decryptVerifyMessageArmored(String publicKey, String privateKey, byte[] passphrase, String ciphertext) throws Exception;
	/**
	 * EncryptAttachment encrypts a file given a plainData and a fileName.
	Returns a PGPSplitMessage containing a session key packet and symmetrically
	encrypted data. Specifically designed for attachments rather than text
	messages.
	 */
	public static native com.proton.gopenpgp.crypto.PGPSplitMessage encryptAttachment(byte[] plainData, String filename, com.proton.gopenpgp.crypto.KeyRing keyRing) throws Exception;
	/**
	 * EncryptAttachmentWithKey encrypts a binary file
	Using a given armored public key.
	 */
	public static native com.proton.gopenpgp.crypto.PGPSplitMessage encryptAttachmentWithKey(String publicKey, String filename, byte[] plainData) throws Exception;
	/**
	 * EncryptBinaryMessageArmored generates an armored PGP message given a binary data and
	an armored public key.
	 */
	public static native String encryptBinaryMessageArmored(String key, byte[] data) throws Exception;
	/**
	 * EncryptMessageArmored generates an armored PGP message given a plaintext and
	an armored public key.
	 */
	public static native String encryptMessageArmored(String key, String plaintext) throws Exception;
	/**
	 * EncryptMessageWithPassword encrypts a string with a passphrase using AES256.
	 */
	public static native String encryptMessageWithPassword(byte[] password, String plaintext) throws Exception;
	/**
	 * EncryptSessionKey encrypts a session key
	using a given armored public key.
	 */
	public static native byte[] encryptSessionKey(String publicKey, com.proton.gopenpgp.crypto.SessionKey sessionKey) throws Exception;
	/**
	 * EncryptSignArmoredDetachedMobile wraps the encryptSignArmoredDetached method
	to have only one return argument for mobile.
	 */
	public static native EncryptSignArmoredDetachedMobileResult encryptSignArmoredDetachedMobile(String publicKey, String privateKey, byte[] passphrase, byte[] plainData) throws Exception;
	/**
	 * EncryptSignBinaryDetachedMobile wraps the encryptSignBinaryDetached method
	to have only one return argument for mobile.
	 */
	public static native EncryptSignBinaryDetachedMobileResult encryptSignBinaryDetachedMobile(String publicKey, String privateKey, byte[] passphrase, byte[] plainData) throws Exception;
	/**
	 * EncryptSignMessageArmored generates an armored signed PGP message given a
	plaintext and an armored public key a private key and its passphrase.
	 */
	public static native String encryptSignMessageArmored(String publicKey, String privateKey, byte[] passphrase, String plaintext) throws Exception;
	/**
	 * FreeOSMemory can be used to explicitly
	call the garbage collector and
	return the unused memory to the OS.
	 */
	public static native void freeOSMemory();
	/**
	 * GenerateKey generates a key of the given keyType (&#34;rsa&#34; or &#34;x25519&#34;), encrypts it, and returns an armored string.
	If keyType is &#34;rsa&#34;, bits is the RSA bitsize of the key.
	If keyType is &#34;x25519&#34; bits is unused.
	 */
	public static native String generateKey(String name, String email, byte[] passphrase, String keyType, long bits) throws Exception;
	/**
	 * GetJsonSHA256Fingerprints returns the SHA256 fingeprints of key and subkeys,
	encoded in JSON, since gomobile can not handle arrays.
	 */
	public static native byte[] getJsonSHA256Fingerprints(String publicKey) throws Exception;
	// skipped function GetSHA256Fingerprints with unsupported parameter or return types
	
	/**
	 * NewGo2AndroidReader wraps a native golang Reader to be usable in the mobile app runtime (via gomobile).
	It doesn&#39;t follow the standard golang Reader behavior, and returns n = -1 on EOF.
	 */
	public static native Go2AndroidReader newGo2AndroidReader(com.proton.gopenpgp.crypto.Reader reader);
	/**
	 * NewGo2IOSReader wraps a native golang Reader to be usable in the ios app runtime (via gomobile).
	 */
	public static native Go2IOSReader newGo2IOSReader(com.proton.gopenpgp.crypto.Reader reader);
	/**
	 * NewMobile2GoReader wraps a MobileReader to be usable in the golang runtime (via gomobile).
	 */
	public static native Mobile2GoReader newMobile2GoReader(MobileReader reader);
	/**
	 * NewMobile2GoWriter wraps a writer to be usable in the golang runtime (via gomobile).
	 */
	public static native Mobile2GoWriter newMobile2GoWriter(com.proton.gopenpgp.crypto.Writer writer);
	/**
	 * NewMobile2GoWriterWithSHA256 wraps a writer to be usable in the golang runtime (via gomobile).
	The wrapper also computes the SHA256 hash of the data being written on the fly.
	 */
	public static native Mobile2GoWriterWithSHA256 newMobile2GoWriterWithSHA256(com.proton.gopenpgp.crypto.Writer writer);
	/**
	 * NewMobileReadResult initialize a MobileReadResult with the correct values.
	It clones the data to avoid the garbage collector freeing the data too early.
	 */
	public static native MobileReadResult newMobileReadResult(long n, boolean eof, byte[] data);
	/**
	 * SignCleartextMessage signs text given a private keyring, canonicalizes and
	trims the newlines, and returns the PGP-compliant special armoring.
	 */
	public static native String signCleartextMessage(com.proton.gopenpgp.crypto.KeyRing keyRing, String text) throws Exception;
	/**
	 * SignCleartextMessageArmored signs text given a private key and its
	passphrase, canonicalizes and trims the newlines, and returns the
	PGP-compliant special armoring.
	 */
	public static native String signCleartextMessageArmored(String privateKey, byte[] passphrase, String text) throws Exception;
	/**
	 * UpdatePrivateKeyPassphrase decrypts the given armored privateKey with oldPassphrase,
	re-encrypts it with newPassphrase, and returns the new armored key.
	 */
	public static native String updatePrivateKeyPassphrase(String privateKey, byte[] oldPassphrase, byte[] newPassphrase) throws Exception;
	/**
	 * VerifyCleartextMessage verifies PGP-compliant armored signed plain text
	given the public keyring and returns the text or err if the verification
	fails.
	 */
	public static native String verifyCleartextMessage(com.proton.gopenpgp.crypto.KeyRing keyRing, String armored, long verifyTime) throws Exception;
	/**
	 * VerifyCleartextMessageArmored verifies PGP-compliant armored signed plain
	text given the public key and returns the text or err if the verification
	fails.
	 */
	public static native String verifyCleartextMessageArmored(String publicKey, String armored, long verifyTime) throws Exception;
	/**
	 * VerifySignatureExplicit calls the reader&#39;s VerifySignature()
	and tries to cast the returned error to a SignatureVerificationError.
	 */
	public static native com.proton.gopenpgp.crypto.SignatureVerificationError verifySignatureExplicit(com.proton.gopenpgp.crypto.PlainMessageReader reader) throws Exception;
}
